chiark / gitweb /
i18n: i18n-diff-auditor: fix multi-arg handling
[dgit.git] / tests / lib
index fa8d6bb58e0847a57bd9bf2bebddb7332fcdd370..a050522890c49fe8bed8076c7584a7ac2dfcc314 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -17,6 +17,8 @@ funcs: ${FUNCNAME[*]}
 lines: ${BASH_LINENO[*]}
 files: ${BASH_SOURCE[*]}
 END
+       t-save-artifacts
+
        exit 16
 }
 
@@ -31,16 +33,18 @@ export DGIT_TEST_DEBUG
 
 : ${DGIT_TEST_DISTRO+ ${distro=${DGIT_TEST_DISTRO}}}
 
-export GIT_COMMITTER_DATE='1440253867 +0100'
-export GIT_AUTHOR_DATE='1440253867 +0100'
+export GIT_COMMITTER_DATE='1530000000 +0100'
+export GIT_AUTHOR_DATE='1530000000 +0100'
 
 root=`pwd`
 troot=$root/tests
 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
 export DGIT_TEST_TROOT=$troot
+bpd=..
 
 tmp=$ADTTMP
 if [ x"$tmp" = x ]; then
+       export DGIT_TEST_BYHAND=1
        mkdir -p tests/tmp
        tmpbase=$troot/tmp
        tmp=tests/tmp/$testname
@@ -58,9 +62,11 @@ t-set-using-tmp
 test -f $tmp/.save-env || \
 env -0 >$tmp/.save-env
 
-ln -f $troot/ssh ssh
+ln -sf $troot/ssh ssh
 
 export DEBCHANGE_VENDOR=dpkg
+unset VISUAL
+unset GIT_EDITOR
 
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
@@ -70,6 +76,9 @@ incoming              = $tmp/incoming
 run_dinstall           = 0
 END
 
+schroot=${DGIT_SCHROOT_CHROOT:-build}
+# Pretty much any Debian sid snapshot schroot will do.
+
 : ${t_archive_method:=aq}
 : ${tagpfx:=archive/test-dummy}
 : ${suitespecs:=sid:unstable}
@@ -83,7 +92,9 @@ t-expect-fail () {
        local mpat="$1"; shift
 
        set +o pipefail
-       LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
+       LC_MESSAGES=${expect_fail_lcmessages-C} \
+       LANGUAGE=${expect_fail_lcmessages-C} \
+       "$@" 2>&1 | tee $tmp/t.output
        local ps="${PIPESTATUS[*]}"
        set -o pipefail
 
@@ -152,7 +163,7 @@ t-reporefs () {
         exec >"$outputfile"
         if test -d $whichrepo; then
                cd $whichrepo
-               git show-ref |sort
+               git show-ref |t-sort
        fi)
 }
 
@@ -189,6 +200,13 @@ t-git-none () {
        (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
 }
 
+t-salsa-add-remote () {
+       local d=$tmp/salsa/$p
+       mkdir -p $d
+       (set -e; cd $d; git init --bare)
+       git remote add ${1-origin} $d
+}
+
 t-git-merge-base () {
        git merge-base $1 $2 || test $? = 1
 }
@@ -326,7 +344,7 @@ t-archive () {
        v=$2
        local dscf=${p}_$2.dsc
        rm -f $tmp/mirror/pool/main/${p}_*
-       ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
+       ln -s $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
        t-archive-query $suite
        rm -rf $tmp/extract
        mkdir $tmp/extract
@@ -360,9 +378,11 @@ t-expect-fsck-fail () {
 }
 
 t-git-fsck () {
+       local fsckerrs=$(git rev-parse --git-dir)/dgit-test-fsck.errs
+
        set +e
        LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
-               | tee dgit-test-fsck.errs
+               | tee $fsckerrs
        ps="${PIPESTATUS[*]}"
        set -e
 
@@ -376,7 +396,7 @@ t-git-fsck () {
        pats+=(-e 'notice: No default references')
 
        set +e
-       grep -v "${pats[@]}" dgit-test-fsck.errs
+       grep -v "${pats[@]}" $fsckerrs
        rc=$?
        set -e
        case $rc in
@@ -386,6 +406,13 @@ t-git-fsck () {
        esac
 }
 
+t-check-only-bpd () {
+       if [ "$bpd" = .. ]; then return; fi
+       t-files-notexist \
+               $tmp/*.{deb,changes,dsc,buildinfo} \
+               $tmp/*.{tar,diff}.*
+}
+
 t-fscks () {
        (
        shopt -s nullglob
@@ -398,10 +425,20 @@ t-fscks () {
 
 t-ok () {
        : '========================================'
+       t-check-only-bpd
        t-fscks
+       t-save-artifacts
        echo ok.
 }
 
+t-save-artifacts () {
+       artifacts="$AUTOPKGTEST_ARTIFACTS"
+       if [ x"$artifacts" = x ]; then return; fi
+       if [ x"tmp" = x ]; then return; fi
+       GZIP=-1v tar -C "$tmp" -zc -f "$artifacts/${0##*/}.tar.gz" \
+               --exclude=\*.tar .
+}
+
 t-rm-dput-dropping () {
        rm -f $tmp/${p}_${v}_*.upload
 }
@@ -413,9 +450,10 @@ t-dgit () {
 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
        $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
  ${dgit_config_debian_alias-"--config-lookup-explode=dgit-distro.debian.alias-canon"} \
+ ${DGIT_GITDEBREBASE_TEST+--git-debrebase=}${DGIT_GITDEBREBASE_TEST} \
                ${distro+${distro:+-d}}${distro--dtest-dummy} \
                $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
-               -k39B13D8A $t_dgit_xopts "$@"
+               -kBCD22CD83243B79D3DFAC33EA3DBCBC039B13D8A $t_dgit_xopts "$@"
        : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
 '
 }
@@ -470,12 +508,12 @@ t-setup-done () {
        local savedirs=$2
        local importeval=$3
 
-       local import=IMPORT.${0##*/}
+       local import=IMPORT.${DGIT_TEST_TESTNAME-${0##*/}}
        exec 4>$tmp/$import.new
 
        local vn
        for vn in $savevars; do
-               perl >&4 -I. -MDebian::Dgit -e '
+               perl >&4 -"I$root" -MDebian::Dgit -e '
                        printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
                ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
        done
@@ -633,6 +671,27 @@ t-check-pushed-master () {
        if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
 }
 
+t-push-was-source-only () {
+        local f
+       t-files-notexist $tmp/incoming/${p}_${v}_*.deb \
+                         $tmp/incoming/${p}_${v}_*.udeb
+       # we permit _source.buildinfo files; see test_changes_source_only()
+       for f in $tmp/incoming/${p}_${v}_*.buildinfo; do
+            if [ -e $f ]; then
+                case "$f" in
+                    *_source.buildinfo) ;;
+                    *) fail "non-source-only file $f exists!" ;;
+                esac
+            fi
+        done
+}
+
+t-push-included () {
+    for f in $@; do
+        stat $tmp/incoming/$f
+    done
+}
+
 t-pushed-good () {
        local branch=$1
        local suite=${2:-sid}
@@ -660,6 +719,12 @@ t-pushed-good-core () {
        git verify-tag `t-v-tag`
 }
 
+t-pushed-good-check-changes () {
+       changes_filename="$tmp/incoming/${p}_${v}_*.changes"
+        grep -E "^Distribution: $suite" $changes_filename
+        grep -E "^Version: $v" $changes_filename
+}
+
 t-splitbrain-pushed-good--unpack () {
        cd $tmp
        rm -rf t-unpack
@@ -971,15 +1036,52 @@ t-make-badcommit () {
        t-expect-fsck-fail $badcommit
 }
 
+t-make-orig () {
+       # leaves ust set to filename of orig tarball
+       local p=$1
+       local v=$2
+       local tag=${3-v$2}
+       ust=${p}_${v}.orig.tar.gz
+       GZIP=-1 git archive -o $bpd/$ust --prefix=${p}-${v}/ $tag
+}
+
+t-merge-conflicted-stripping-conflict-markers () {
+       local otherbranch=$1
+       local file=$2
+
+       t-expect-fail F:"Merge conflict in $file" \
+       git merge $otherbranch
+
+       perl -i~ -ne 'print unless m{^(?:\<\<\<|\>\>\>|===)}' "$file"
+       git add "$file"
+       git commit --no-edit
+}
+
 t-commit () {
        local msg=$1
        v=${2:-${majorv:-1}.$revision}
-       dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
+       $troot/tstunt/debchange \
+               --force-distribution -v$v --distribution ${3:-unstable} "$1"
        git add debian/changelog
        debcommit
        revision=$(( ${revision-0} + 1 ))
 }
 
+t-dch-r-rune () {
+       local cmd="$1"; shift
+       local suite=${1-unstable}
+       $cmd -r -D "$suite" ''
+}
+
+t-dch-commit-r () {
+       t-dch-r-rune t-dch-commit "$@"
+}
+
+t-dch-commit () {
+       $troot/tstunt/debchange "$@"
+       git commit -m "dch $*" debian/changelog
+}
+
 t-git-config () {
        git config --global "$@"
 }
@@ -1077,6 +1179,16 @@ t-policy-periodic () {
        : '))))))))))))))))))))))))))))))))))))))))'
 }
 
+t-buildproductsdir-config () {
+       bpd=$tmp/bpd
+       t-git-config dgit.default.build-products-dir $bpd
+       mkdir -p $bpd
+       cat <<END >>$tmp/.gbp.conf
+[buildpackage]
+export-dir = $bpd
+END
+}
+
 t-restrict () {
        local restriction=$1
        (cd $root; t-restriction-$restriction >&2)
@@ -1104,7 +1216,11 @@ t-alt-test () {
 
 t-git-config dgit.default.old-dsc-distro test-dummy
 
-case "$0" in
-*/gnupg) ;;
-*)     t-setup-import gnupg    ;;
-esac
+for import in ${autoimport-gnupg}; do
+       case "$0" in
+       */$import) ;;
+       *)
+               t-setup-import $import
+               ;;
+       esac
+done